﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using Newtonsoft.Json;
using Syncfusion.JavaScript;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Data(Syncfusion.JavaScript.DataManager dm)
        {
            
            IEnumerable DataSource = new NorthwindDataContext().OrdersViews.ToList();
            DataOperations dp = new DataOperations();
            DataResult result = new DataResult();
            result.count = DataSource.AsQueryable().Count();
            if (dm.Where != null)
            {
                DataSource = dp.PerformWhereFilter(DataSource, dm.Where, dm.Where[0].Operator);
                result.count = DataSource.AsQueryable().Count();//updates the origninal record count after filtering
                if (dm.Take == 0)
                    return Json(DataSource, JsonRequestBehavior.AllowGet);//Return records alone for the autoComplete list
            }
            DataSource = dp.Execute(DataSource, dm);
            result.result = DataSource;
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Index()
        {
            return View();
        }
        public ActionResult CrudUpdate(EditableOrder value, string action) {
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
            public IEnumerable aggregate { get; set; }
            public IEnumerable groupDs { get; set; }
        }
    }
}